module PDF
    # Based on [ruby-talk:20551]. Updated to (hopefully) be 1.8 friendly.
  class OHash < Hash
    alias_method :store, :[]=
    alias_method :each_pair, :each

    def initialize(*args)
      @keys = []
      super
    end

    def []=(key, val)
      @keys << key unless has_key?(key)
      super
    end

    def delete(key)
      @keys.delete(key) if has_key?(key)
      super
    end

    def each
      @keys.each { |k| yield k, self[k] }
    end

    def each_key
      @keys.each { |k| yield k }
    end

    def each_value
      @keys.each { |k| yield self[k] }
    end
  end
end
