module PDF
  class Writer
      # An action object, used to link to URLS initially
    class Action < PDF::Writer::WriterObject
      def initialize(parent, label, type = "URI")
        super(parent)

        @type = type
        @label = label
      end

      attr_accessor :type
      attr_accessor :label

      def to_s
        @parent.arc4.prepare(self) if @parent.encrypted?
        res = "\n#{@id} 0 obj\n<< /Type /Action"
        if @type == :ilink
          res << "\n/S /GoTo\n/D #{@parent.destinations[@label].id} 0 R"
        elsif @type == 'URI'
          res << "\n/S /URI\n/URI ("
          if @parent.encrypted?
            res << PDF.escape(@parent.arc4.encrypt(@label))
          else
            res << PDF.escape(@label)
          end
          res << ")\n"
        end
        res << ">>\nendobj"
      end
    end
  end
end
