module PDF
  class Writer
      # Destination object, used to specify the location for the user to jump
      # to; presently, only on opening.
    class Destination < PDF::Writer::WriterObject
      def initialize(parent, page, type, p1 = 0, p2 = 0, p3 = 0)
        super(parent)

        case type
        when "XYZ", "FitR"
          @string = "/#{type} #{p1} #{p2} #{p3}"
        when "FitH", "FitV", "FitBH", "FitBV"
          @string = "/#{type} #{p1} #{p2}"
        when "Fit", "FitB"
          @string = "/#{type}"
        end

        @page = page
      end

      attr_accessor :string
      attr_accessor :page

      def to_s
        "\n#{@id} 0 obj\n[#{@page.id} 0 R #{@string}]\nendobj\n"
      end
    end
  end
end
