module PDF
  class Writer
      # Encryption object
    class Encryption < PDF::Writer::WriterObject

      PAD__ = [0x28, 0xBF, 0x4E, 0x5E, 0x4E, 0x75, 0x8A, 0x41, 0x64, 0x00,
               0x4E, 0x56, 0xFF, 0xFA, 0x01, 0x08, 0x2E, 0x2E, 0x00, 0xB6,
               0xD0, 0x68, 0x3E, 0x80, 0x2F, 0x0C, 0xA9, 0xFE, 0x64, 0x53,
               0x69, 0x7A]
      PAD = ("%c" * PAD__.size) % PAD__

      def initialize(parent, options)
        super(parent)

        @parent.encrypt_obj = self

          # figure out the additional paramaters required
        @owner = "#{options[:owner]}#{PAD}"[0..31]
        @user = "#{options[:user]}#{PAD}"[0..31]

        @p = options[:password]

        @parent.arc4.prepare(PDF::ARC4.md5_16byte(@owner)[0..4])
        @o = @parent.arc4.encrypt(@user)

        t = PDF::ARC4.md5_16byte("#{@user}#{@o}%c" % [@p])
        t << ("%c%c%c" % [0xFF, 0xFF, 0xFF]) + @parent.file_identifier
        ukey = t[0..4]
        @parent.encrypted = true
        @parent.encryption_key = ukey

        @parent.arc4.prepare(ukey)
        @u = @parent.arc4.encrypt(PAD)
        @parent.encryption_key = ukey
      end

      def to_s
        res = "\n#{@id} 0 obj\n<<\n/Filter /Standard\n/V 1\n/R 2\n/O (#{PDF.escape(@o)})\n/U (#{PDF.escape(@u)})"
          # Convert the @p value to account for the twos-complement approach
        p = ((@p ^ 255) + 1) * -1
        res << "\n/P #{p}\n>>\nendobj\n"
        res
      end
    end
  end
end
