module PDF
  class Writer
      # The font encoding
    class FontEncoding < PDF::Writer::WriterObject
      def initialize(parent, encoding, differences)
        super(parent)

        @differences  = differences
        @encoding     = encoding
      end

      attr_accessor :differences
      attr_accessor :encoding

      def to_s
        res = "\n#{@id} 0 obj\n<< /Type /Encoding\n"
        enc = @encoding || 'WinAnsiEncoding'
        res << "/BaseEncoding /#{enc}\n" unless enc == 'none'
        res << "/Differences \n["
        n = -100
        differences.each do |k, v|
          if k != (n + 1)
            res << "\n#{k} /#{v}" # Cannot make use of consecutive numbering
          else
            res << " /#{v}"
          end
          n = k
        end
        res << "\n]\n>>\nendobj"
      end
    end
  end
end
