module PDF
  class Writer
      # define the document information
    class Info < PDF::Writer::WriterObject
      Info = %w{CreationDate Creator Title Author Subject Keywords ModDate Trapped Producer}
      def initialize(parent)
        super(parent)

        @parent.info = self
        now = Time.now
        @creationdate = "D:%04d%02d%02d" % [now.year, now.month, now.day]
        @creator = nil
        @producer = "Ruby PDF::Writer, http://www.halostatue.ca/"
        @title = nil
        @author = nil
        @subject = nil
        @keywords = nil
        @moddate = nil
        @trapped = nil
      end

      Info.each do |i|
        attr_accessor i.downcase.intern
      end

      def to_s
        @parent.arc4.prepare(self) if @parent.encrypted?
        res = "\n#{@id} 0 obj\n<<\n"
        Info.each do |i|
          v = __send__("#{i.downcase}".intern)
          next if v.nil?
          res << "/#{i} ("
          if @parent.encrypted?
            res << PDF.escape(@parent.arc4.encrypt(v))
          else
            res << PDF.escape(v)
          end
          res << ")\n"
        end
        res << ">>\nendobj"
      end
    end
  end
end
