module PDF
  class Writer
      # Define the outlines in the doc, empty for now
    class Outlines < PDF::Writer::WriterObject
      def initialize(parent)
        super(parent)

        @outlines = []
        @parent.catalog.outlines = self
      end

      attr_reader :outlines

      def to_s
        unless @outlines.empty?
          res = "\n#{@id} 0 obj\n<< /Type /Outlines /Kids ["
          @outlines.each do |v|
            res << "#{v.id} 0 R "
          end
          res << "] /Count #{@outlines.size} >>\nendobj"
        else
          "\n#{@id} 0 obj\n<< /Type /Outlines /Count 0 >>\nendobj"
        end
      end
    end
  end
end
