module PDF
  class Writer
      # Set the viewer preferences
    class ViewerPreferences < PDF::Writer::WriterObject
      Preferences = %w{HideToolbar HideMenubar HideWindowUI FitWindow CenterWindow NonFullScreenPageMode Direction}

      def initialize(parent)
        super(parent)
      end

      Preferences.each do |s|
        attr_accessor s.downcase.intern
      end

      def to_s
        res = "\n#{@id} 0 obj\n<< "
        Preferences.each do |s|
          v = __send__("#{s.downcase}=".intern)
          res << "\n/#{s} #{v}" unless v.nil?
        end
        res << "\n>>\n"
      end
    end
  end
end
