# Add library path
$: << "pdf-writer/lib"
$: << "lib"

require 'pdf/ezwriter'

pdf = PDF::EZWriter.new("A4", :portrait)

black = PDF::Color.new(0,0,0)
white = PDF::Color.new(1,1,1)

x = 300
y = 500
# Draw circle
r = 250
pdf.set_color(black)
pdf.filled_ellipse(x,y,r)

# Draw teeth
r = 230
n_teeth = 60
n_missing = 2
thickness = 15

deg_p_teeth = 360.0/(n_teeth*2)
pdf.set_line_style(thickness)
pdf.set_stroke_color(white)
deg = 0
# 60-2 disc:
(n_teeth-n_missing).times{
    pdf.part_ellipse(x, y, deg, deg+deg_p_teeth, r)
    deg += deg_p_teeth*2
}

# Draw home  
# Not needed for me, but if you want it; just add more part_ellipse as done before
# and reduce 'r'

output = pdf.ez_output
File.open("trigger.pdf", "w") { |f| f << output }

